import * as React from "react";
import { IDataBinder } from "../../form/formCore";
import { FormBinderBase } from "../../form/formBinders";
export interface IDateInputProps extends React.Props<DateInput> {
    /** (string) Date string in YYYY-MM-DD format */
    date?: string;
    /** ((string) => void) Event which returns the date when it changes and is valid */
    onChange?: (date: string) => void;
    /** (number) How many years from the current year to display in the year dropdown */
    yearsFromNow?: number;
    /** (boolean) Should the picker let you choose years from the future rather than the past */
    futureDates?: boolean;
    /** (boolean) Should the picker disallow user interaction */
    disabled?: boolean;
}
export interface IDateInputState {
    day?: number;
    month?: number;
    year?: number;
    date?: string;
}
export declare class DateInput extends React.Component<IDateInputProps, IDateInputState> {
    private cId;
    constructor();
    getDaysArrayByMonth(): string[];
    dayChanged(day: string): void;
    monthChanged(month: string): void;
    yearChanged(year: string): void;
    componentWillMount(): void;
    componentWillReceiveProps(newProps: IDateInputProps): void;
    buildDate(): void;
    createDate(): string;
    render(): JSX.Element;
}
export declare class DateInputFormBinder extends FormBinderBase<IDateInputProps, string, string> {
    static customValue(dataName: string): DateInputFormBinder;
    handleValueChanged(props: IDateInputProps, dataBinder: IDataBinder<any>, notifyChanged: () => void): void;
}
